/*******************************************************************************
 * Copyright (c) 2010- Association for Decentralized Information Management in
 * Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.history;

import org.simantics.databoard.accessor.Accessor;

/**
 * Sample collector reads values from a datasource, samples them and 
 * adds to a record session.
 * 
 * Recording Session is a time series storage format. 
 * https://www.simantics.org/wiki/index.php/Databoard_Specification#History_Contract
 * 
 * There is a contract for the structure of data sources
 * https://www.simantics.org/wiki/index.php/Databoard_Specification#Datasource_Contract 
 * 
 * @author Toni Kalajainen <toni.kalajainen@vtt.fi>
 */
public class SampleCollector {
	
	Accessor datasource;
	Accessor recordingSession;
	Object samplingConfiguration;
	
	/**
	 * Create sample collector 
	 * @param datasource
	 * @param recordingSession
	 * @param samplingConfiguration
	 */
	public SampleCollector(Accessor datasource, Accessor recordingSession, Object samplingConfiguration) 
	{
		this.datasource = datasource;
		this.recordingSession = recordingSession;
		this.samplingConfiguration = samplingConfiguration;
	}
	
	/**
	 * Start collecting samples
	 */
	public void start() {
		
	}
	
	/**
	 * Stop collecting samples 
	 */
	public void stop() {
		
	}	

}

